﻿using EJGrid.Models;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Linq;
using System.Linq.Expressions;
using System.Web;
using System.Web.Mvc;
using System.Web.UI.WebControls;
using System.Xml;
using System.Web.Script.Serialization;
using System.Reflection;
using System.Web.Helpers;

namespace EJGrid.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            ViewBag.datasource = OrderRepository.GetAllRecords();
            return View();
        }
        public ActionResult _GetEmployees(int skip, int take, List<Filter> where, List<Sorted> sorted)
        {

            var model = new NorthwindDataContext().EmployeeViews.ToList();
            if (where != null)
            {
                foreach (var filtre in where)
                {
                    var paramExpression = Expression.Parameter(model.AsQueryable().ElementType, model.AsQueryable().ElementType.Name);
                    var memExp = Expression.PropertyOrField(paramExpression, filtre.Field);
                    var bExp = Expression.Equal(memExp, Expression.Constant(Convert.ChangeType(filtre.Value, memExp.Type), memExp.Type));
                    var lambda = Expression.Lambda(bExp, paramExpression);
                    model = model.AsQueryable().Provider.CreateQuery(Expression.Call(typeof(Queryable), "Where", new Type[] { model.AsQueryable().ElementType }, model.AsQueryable().Expression, lambda)).Cast<EmployeeView>().ToList();
                }

            }

            var count = model.Count;
            if (sorted != null)
            {
                foreach (var sort in sorted)
                {
                    var type = typeof(EmployeeView);
                    var property = type.GetProperty(sort.Name);
                    var parameter = Expression.Parameter(type, "p");
                    var propertyAccess = Expression.MakeMemberAccess(parameter, property);
                    var orderByExp = Expression.Lambda(propertyAccess, parameter);
                    MethodCallExpression resultExp;
                    if(sort.Direction == "ascending")
                     resultExp = Expression.Call(typeof(Queryable), "OrderBy", new Type[] { type, property.PropertyType }, model.AsQueryable().Expression, Expression.Quote(orderByExp));
                    else
                        resultExp = Expression.Call(typeof(Queryable), "OrderByDescending", new Type[] { type, property.PropertyType }, model.AsQueryable().Expression, Expression.Quote(orderByExp));
                    model = model.AsQueryable().Provider.CreateQuery<EmployeeView>(resultExp).Cast<EmployeeView>().ToList();
                } 
            }
            model = model.Skip(skip).Take(take).ToList();
            return Json(new { result = model, count = count }, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
        public class Filter
        {
            public string Field { get; set; }
            public string Operator { get; set; }
            public string Value { get; set; }
            public bool IgnoreCase { get; set; }
            public bool IsComplex  { get; set; }
            public string Condition { get; set; }
            public List<Filter> predicates { get; set; }

        }
        public class Sorted
        {
            public string Name { get; set; }
            public string Direction { get; set; }
        }
    }
}